diff --git a/config/queue.php b/config/queue.php
index 9119228..38326ef 100644
--- a/config/queue.php
+++ b/config/queue.php
@@ -4,19 +4,16 @@ return [
 
     /*
     |--------------------------------------------------------------------------
-    | Default Queue Driver
+    | Default Queue Connection Name
     |--------------------------------------------------------------------------
     |
-    | The Laravel queue API supports a variety of back-ends via an unified
+    | Laravel's queue API supports an assortment of back-ends via a single
     | API, giving you convenient access to each back-end using the same
-    | syntax for each one. Here you may set the default queue driver.
-    |
-    | Supported: "null", "sync", "database", "beanstalkd",
-    |            "sqs", "iron", "redis"
+    | syntax for every one. Here you may define a default connection.
     |
     */
 
-    'default' => env('QUEUE_DRIVER', 'sync'),
+    'default' => env('QUEUE_CONNECTION', 'sync'),
 
     /*
     |--------------------------------------------------------------------------
@@ -27,6 +24,8 @@ return [
     | is used by your application. A default configuration has been added
     | for each back-end shipped with Laravel. You are free to add more.
     |
+    | Drivers: "sync", "database", "beanstalkd", "sqs", "redis", "null"
+    |
     */
 
     'connections' => [
@@ -51,11 +50,11 @@ return [
 
         'sqs' => [
             'driver' => 'sqs',
-            'key' => 'your-public-key',
-            'secret' => 'your-secret-key',
-            'prefix' => 'https://sqs.us-east-1.amazonaws.com/your-account-id',
-            'queue' => 'your-queue-name',
-            'region' => 'us-east-1',
+            'key' => env('SQS_KEY', 'your-public-key'),
+            'secret' => env('SQS_SECRET', 'your-secret-key'),
+            'prefix' => env('SQS_PREFIX', 'https://sqs.us-east-1.amazonaws.com/your-account-id'),
+            'queue' => env('SQS_QUEUE', 'your-queue-name'),
+            'region' => env('SQS_REGION', 'us-east-1'),
         ],
 
         'redis' => [
diff --git a/config/services.php b/config/services.php
index 74d047e..66bad94 100644
--- a/config/services.php
+++ b/config/services.php
@@ -25,6 +25,10 @@ return [
         'region' => 'us-east-1',
     ],
 
+    'sparkpost' => [
+        'secret' => env('SPARKPOST_SECRET'),
+    ],
+
     'stripe' => [
         'model'  => Portal\User::class,
         'key'    => env('STRIPE_KEY'),
diff --git a/config/session.php b/config/session.php
index 3219fbc..307b7e5 100644
--- a/config/session.php
+++ b/config/session.php
@@ -70,7 +70,7 @@ return [
     |
     */
 
-    'connection' => null,
+    'connection' => env('SESSION_CONNECTION', null),
 
     /*
     |--------------------------------------------------------------------------
@@ -95,7 +95,7 @@ return [
     | correspond with one of the application's configured cache stores.
     |
     */
-    'store' => null,
+    'store' => env('SESSION_STORE', null),
 
     /*
     |--------------------------------------------------------------------------
diff --git a/database/migrations/2015_12_29_224252_create_user_activity_table.php b/database/migrations/2015_12_29_224252_create_user_activity_table.php
index d0c4571..24ce08a 100644
--- a/database/migrations/2015_12_29_224252_create_user_activity_table.php
+++ b/database/migrations/2015_12_29_224252_create_user_activity_table.php
@@ -36,9 +36,11 @@ class CreateUserActivityTable extends Migration
      */
     public function down()
     {
-        Schema::table('user_activity', function (Blueprint $table) {
-            $table->dropForeign('user_activity_user_id_foreign');
-        });
+        if (DB::getDriverName() != 'sqlite') {
+            Schema::table('user_activity', function (Blueprint $table) {
+                $table->dropForeign('user_activity_user_id_foreign');
+            });
+        }
 
         Schema::drop('user_activity');
     }
diff --git a/database/migrations/2015_12_30_171734_add_foreign_keys.php b/database/migrations/2015_12_30_171734_add_foreign_keys.php
index e1633eb..1285b12 100644
--- a/database/migrations/2015_12_30_171734_add_foreign_keys.php
+++ b/database/migrations/2015_12_30_171734_add_foreign_keys.php
@@ -38,13 +38,15 @@ class AddForeignKeys extends Migration
      */
     public function down()
     {
-        Schema::table('users', function (Blueprint $table) {
-            $table->dropForeign('users_country_id_foreign');
-            $table->dropForeign('users_role_id_foreign');
-        });
+        if (DB::getDriverName() != 'sqlite') {
+            Schema::table('users', function (Blueprint $table) {
+                $table->dropForeign('users_country_id_foreign');
+                $table->dropForeign('users_role_id_foreign');
+            });
 
-        Schema::table('social_logins', function (Blueprint $table) {
-            $table->dropForeign('social_logins_user_id_foreign');
-        });
+            Schema::table('social_logins', function (Blueprint $table) {
+                $table->dropForeign('social_logins_user_id_foreign');
+            });
+        }
     }
 }
diff --git a/database/migrations/2017_04_13_200254_create_api_tokens_table.php b/database/migrations/2017_04_13_200254_create_api_tokens_table.php
index 4529f98..6abcecf 100644
--- a/database/migrations/2017_04_13_200254_create_api_tokens_table.php
+++ b/database/migrations/2017_04_13_200254_create_api_tokens_table.php
@@ -40,9 +40,11 @@ class CreateApiTokensTable extends Migration
      */
     public function down()
     {
-        Schema::table('api_tokens', function (Blueprint $table) {
-            $table->dropForeign('api_tokens_user_id_foreign');
-        });
+        if (DB::getDriverName() != 'sqlite') {
+            Schema::table('api_tokens', function (Blueprint $table) {
+                $table->dropForeign('api_tokens_user_id_foreign');
+            });
+        }
 
         Schema::dropIfExists('api_tokens');
     }
diff --git a/public/assets/js/as/two-factor.js b/public/assets/js/as/two-factor.js
new file mode 100644
index 0000000..0a739bb
--- /dev/null
+++ b/public/assets/js/as/two-factor.js
@@ -0,0 +1,36 @@
+var timer;
+var $btn = $("#resend-token");
+
+/**
+ * Start timeout which will show the "Resend Token" button
+ * after 60 seconds.
+ */
+function startTimer() {
+    timer = setTimeout(function () {
+        $btn.removeClass('d-none');
+    }, 60 * 1000);
+}
+
+/**
+ * Resend phone verification token.
+ */
+function resendToken() {
+    as.btn.loading($btn, $btn.data('loading-text'));
+
+    $.post("/two-factor/resend", user ? {user: user} : {})
+        .then(handleResendResponse)
+        .catch(handleResendResponse);
+}
+
+/**
+ * Handle response received from the server after
+ * resend token request was sent.
+ */
+function handleResendResponse() {
+    as.btn.stopLoading($btn);
+    $btn.addClass('d-none');
+    startTimer();
+}
+
+$btn.click(resendToken);
+startTimer();
\ No newline at end of file
diff --git a/resources/lang/de/app.php b/resources/lang/de/app.php
index 6c7e46a..627eeea 100644
--- a/resources/lang/de/app.php
+++ b/resources/lang/de/app.php
@@ -86,6 +86,14 @@ return [
 
     // 2FA
     'two_factor_authentication' => 'Zwei-Faktor Authentifizierung',
+    'two_factor_phone_verification' => 'Zwei-Faktor Überprüfung der Telefonnummer',
+    'phone_verification' => 'Überprüfung der Telefonnummer',
+    'we_have_sent_you_a_verification_token' => 'Wir haben Ihnen ein Bestätigungstoken per SMS gesendet.
+     Bitte geben Sie den Token unten ein, um Ihre Telefonnummer zu bestätigen.',
+    'verify' => 'Überprüfen',
+    'verifying' => 'Überprüfung...',
+    'resend_token' => 'Erneut senden Token',
+    'sending' => 'Senden...',
     'token' => 'Token',
     'authy_2fa_token' => 'Authy 2FA Token',
     'enable_disable_2fa' => 'Aktivieren/Deaktivieren Zwei-Faktor Authentifizierung für die Anwendung.',
@@ -326,5 +334,9 @@ return [
     'unknown' => 'Unbekannt',
     'device' => 'Device',
     'browser' => 'Browser',
-    'invalid_social_auth' => "Bei der Authentifizierung ist ein Fehler aufgetreten. Bitte versuche es erneut."
+    'invalid_social_auth' => "Bei der Authentifizierung ist ein Fehler aufgetreten. Bitte versuche es erneut.",
+
+    'impersonate' => 'Impersonate',
+    'impersonate_user' => 'Impersonate User',
+    'stop_impersonating' => 'Stop Impersonating'
 ];
diff --git a/resources/lang/de/log.php b/resources/lang/de/log.php
index 3883302..05f6668 100644
--- a/resources/lang/de/log.php
+++ b/resources/lang/de/log.php
@@ -25,5 +25,8 @@ return [
     'enabled_2fa_for' => 'Zwei-Faktor Authentifizierung für Benutzer :name wurde aktiviert.',
     'disabled_2fa_for' => 'Zwei-Faktor Authentifizierung für Benutzer :name wurde deaktiviert.',
     'requested_password_reset' => 'Mail zum Zurücksetzen des Passworts wurde angefordert.',
-    'reseted_password' => 'Das Passwort wurde mit Hilfe der Option "Passwort vergessen" zurückgesetzt.'
+    'reseted_password' => 'Das Passwort wurde mit Hilfe der Option "Passwort vergessen" zurückgesetzt.',
+
+    'started_impersonating' => 'Gestartet Identitätswechsel Benutzer :name (ID: :id)',
+    'stopped_impersonating' => 'Gestoppt Identitätswechsel Benutzer :name (ID: :id)',
 ];
diff --git a/resources/lang/en/app.php b/resources/lang/en/app.php
index 4ac59f5..940843a 100644
--- a/resources/lang/en/app.php
+++ b/resources/lang/en/app.php
@@ -86,6 +86,14 @@ return [
 
     // 2FA
     'two_factor_authentication' => 'Two-Factor Authentication',
+    'two_factor_phone_verification' => 'Two-Factor Phone Verification',
+    'phone_verification' => 'Phone Verification',
+    'we_have_sent_you_a_verification_token' => 'We have sent you a verification token via SMS. 
+    Please provide the token below to verify your phone number.',
+    'verify' => 'Verify',
+    'verifying' => 'Verifying...',
+    'resend_token' => 'Resend Token',
+    'sending' => 'Sending...',
     'token' => 'Token',
     'authy_2fa_token' => 'Authy 2FA Token',
     'enable_disable_2fa' => 'Enable/Disable Two-Factor Authentication for the application.',
@@ -329,5 +337,9 @@ return [
     'unknown' => 'Unknown',
     'device' => 'Device',
     'browser' => 'Browser',
-    'invalid_social_auth' => "Something went wrong during the authentication process. Please try again."
+    'invalid_social_auth' => "Something went wrong during the authentication process. Please try again.",
+
+    'impersonate' => 'Impersonate',
+    'impersonate_user' => 'Impersonate User',
+    'stop_impersonating' => 'Stop Impersonating'
 ];
diff --git a/resources/lang/en/log.php b/resources/lang/en/log.php
index 5742834..618e49e 100644
--- a/resources/lang/en/log.php
+++ b/resources/lang/en/log.php
@@ -25,5 +25,8 @@ return [
     'enabled_2fa_for' => 'Enabled Two-Factor Authentication for user :name.',
     'disabled_2fa_for' => 'Disabled Two-Factor Authentication for user :name.',
     'requested_password_reset' => 'Requested password reset email.',
-    'reseted_password' => 'Reseted password using "Forgot Password" option.'
+    'reseted_password' => 'Reseted password using "Forgot Password" option.',
+
+    'started_impersonating' => 'Started impersonating user :name (ID: :id)',
+    'stopped_impersonating' => 'Stopped impersonating user :name (ID: :id)',
 ];
diff --git a/resources/lang/sr/app.php b/resources/lang/sr/app.php
index 9980d52..2b8ec53 100644
--- a/resources/lang/sr/app.php
+++ b/resources/lang/sr/app.php
@@ -86,6 +86,14 @@ return [
 
     // 2FA
     'two_factor_authentication' => 'Two-Factor autentifikacija',
+    'two_factor_phone_verification' => 'Verifikacija telefonskog broja',
+    'phone_verification' => 'Verifikacija telefonskog broja',
+    'we_have_sent_you_a_verification_token' => 'Poslali smo Vam token za verifikaciju putem SMS-a. 
+    Molimo Vas upišite token koji ste dobili u polje ispod kako biste verifikovali Vaš broj telefona.',
+    'verify' => 'Verifikuj',
+    'verifying' => 'Verifikacija...',
+    'resend_token' => 'Ponovo Pošalji Token',
+    'sending' => 'Slanje...',
     'token' => 'Token',
     'authy_2fa_token' => 'Authy 2FA token',
     'enable_disable_2fa' => 'Omogući/Onemogući Two-Factor autentifikaciju u aplikaciji.',
@@ -333,5 +341,9 @@ return [
     'unknown' => 'Nepoznato',
     'device' => 'Uređaj',
     'browser' => 'Pretraživač',
-    'invalid_social_auth' => "Došlo je do problema prilikom autentifikacije. Molimo pokušajte ponovo."
+    'invalid_social_auth' => "Došlo je do problema prilikom autentifikacije. Molimo pokušajte ponovo.",
+
+    'impersonate' => 'Predstavi se kao on',
+    'impersonate_user' => 'Predstavi se kao korisnik',
+    'stop_impersonating' => 'Prekini lažno predstavljanje'
 ];
diff --git a/resources/lang/sr/log.php b/resources/lang/sr/log.php
index 144225b..9b9712d 100644
--- a/resources/lang/sr/log.php
+++ b/resources/lang/sr/log.php
@@ -25,5 +25,8 @@ return [
     'enabled_2fa_for' => 'Aktivirao je Two-Factor autentifikaciju za korisnika :name.',
     'disabled_2fa_for' => 'Disabled Two-Factor autentifikaciju za korisnika :name.',
     'requested_password_reset' => 'Zatražio je e-mail za obnavljanje lozinke.',
-    'reseted_password' => 'Obnovio je lozinku korišćenjem opcije "Zaboravljena lozinka".'
+    'reseted_password' => 'Obnovio je lozinku korišćenjem opcije "Zaboravljena lozinka".',
+
+    'started_impersonating' => 'Započeo je lažno predstavljanje korisnika :name (ID: :id)',
+    'stopped_impersonating' => 'Završio je sa lažnim predstavljanjem korisnika :name (ID: :id)',
 ];
diff --git a/resources/views/partials/navbar.blade.php b/resources/views/partials/navbar.blade.php
index a5cae49..5bc483c 100644
--- a/resources/views/partials/navbar.blade.php
+++ b/resources/views/partials/navbar.blade.php
@@ -7,6 +7,12 @@
     </div>
 
     <div>
+        @if (app('impersonate')->isImpersonating())
+            <a href="{{ route('impersonate.leave') }}" class="navbar-toggler text-danger hidden-md">
+                <i class="fas fa-user-secret"></i>
+            </a>
+        @endif
+
         <button class="navbar-toggler" type="button" id="sidebar-toggle">
             <i class="fas fa-align-right text-muted"></i>
         </button>
@@ -42,6 +48,15 @@
         </div>
 
         <ul class="navbar-nav ml-auto pr-3">
+            @if (app('impersonate')->isImpersonating())
+                <li class="nav-item d-flex align-items-center visible-lg">
+                    <a href="{{ route('impersonate.leave') }}" class="btn text-danger">
+                        <i class="fas fa-user-secret mr-2"></i>
+                        @lang('app.stop_impersonating')
+                    </a>
+                </li>
+            @endif
+
             <li class="nav-item dropdown">
                 <a class="nav-link dropdown-toggle"
                    href="#"
diff --git a/resources/views/settings/notifications.blade.php b/resources/views/settings/notifications.blade.php
index 359feed..c2daee5 100644
--- a/resources/views/settings/notifications.blade.php
+++ b/resources/views/settings/notifications.blade.php
@@ -30,6 +30,8 @@
                     <div class="form-group my-4">
                         <div class="d-flex align-items-center">
                             <div class="switch">
+                                <input type="hidden" value="0" name="notifications_signup_email">
+
                                 <input type="checkbox"
                                        name="notifications_signup_email"
                                        class="switch"
diff --git a/resources/views/user/edit.blade.php b/resources/views/user/edit.blade.php
index e011ea0..99c5636 100644
--- a/resources/views/user/edit.blade.php
+++ b/resources/views/user/edit.blade.php
@@ -80,7 +80,8 @@
                         <div class="tab-pane fade px-2" id="2fa" role="tabpanel" aria-labelledby="nav-profile-tab">
                             <?php $route = Authy::isEnabled($user) ? 'disable' : 'enable'; ?>
 
-                            {!! Form::open(['route' => ["user.two-factor.{$route}", $user->id], 'id' => 'two-factor-form']) !!}
+                            {!! Form::open(['route' => "two-factor.{$route}", 'id' => 'two-factor-form']) !!}
+                                <input type="hidden" name="user" value="{{ $user->id }}">
                                 @include('user.partials.two-factor')
                             {!! Form::close() !!}
                         </div>
@@ -111,6 +112,6 @@
     {!! JsValidator::formRequest('Portal\Http\Requests\User\UpdateLoginDetailsRequest', '#login-details-form') !!}
 
     @if (settings('2fa.enabled'))
-        {!! JsValidator::formRequest('Portal\Http\Requests\User\EnableTwoFactorRequest', '#two-factor-form') !!}
+        {!! JsValidator::formRequest('Portal\Http\Requests\TwoFactor\EnableTwoFactorRequest', '#two-factor-form') !!}
     @endif
 @stop
\ No newline at end of file
diff --git a/resources/views/user/partials/row.blade.php b/resources/views/user/partials/row.blade.php
index fb47a71..4c78bc4 100644
--- a/resources/views/user/partials/row.blade.php
+++ b/resources/views/user/partials/row.blade.php
@@ -41,6 +41,12 @@
                     <i class="fas fa-eye mr-2"></i>
                     @lang('app.view_user')
                 </a>
+                @canBeImpersonated($user)
+                    <a href="{{ route('impersonate', $user->id) }}" class="dropdown-item text-gray-500 impersonate">
+                        <i class="fas fa-user-secret mr-2"></i>
+                        @lang('app.impersonate')
+                    </a>
+                @endCanBeImpersonated
             </div>
         </div>
 
@@ -50,6 +56,7 @@
            data-toggle="tooltip" data-placement="top">
             <i class="fas fa-edit"></i>
         </a>
+
         <a href="{{ route('user.delete', $user->id) }}"
            class="btn btn-icon"
            title="@lang('app.delete_user')"
diff --git a/resources/views/user/profile.blade.php b/resources/views/user/profile.blade.php
index 862afa4..f0b3582 100644
--- a/resources/views/user/profile.blade.php
+++ b/resources/views/user/profile.blade.php
@@ -72,7 +72,7 @@
                         <div class="tab-pane fade px-2" id="2fa" role="tabpanel" aria-labelledby="nav-profile-tab">
                             <?php $route = Authy::isEnabled($user) ? 'disable' : 'enable'; ?>
 
-                            {!! Form::open(['route' => "profile.two-factor.{$route}", 'id' => 'two-factor-form']) !!}
+                            {!! Form::open(['route' => "two-factor.{$route}", 'id' => 'two-factor-form']) !!}
                                 @include('user.partials.two-factor')
                             {!! Form::close() !!}
                         </div>
@@ -103,6 +103,6 @@
     {!! JsValidator::formRequest('Portal\Http\Requests\User\UpdateProfileLoginDetailsRequest', '#login-details-form') !!}
 
     @if (settings('2fa.enabled'))
-        {!! JsValidator::formRequest('Portal\Http\Requests\User\EnableTwoFactorRequest', '#two-factor-form') !!}
+        {!! JsValidator::formRequest('Portal\Http\Requests\TwoFactor\EnableTwoFactorRequest', '#two-factor-form') !!}
     @endif
 @stop
\ No newline at end of file
diff --git a/resources/views/user/two-factor-verification.blade.php b/resources/views/user/two-factor-verification.blade.php
new file mode 100644
index 0000000..9eada67
--- /dev/null
+++ b/resources/views/user/two-factor-verification.blade.php
@@ -0,0 +1,69 @@
+@extends('layouts.app')
+
+@section('page-title', trans('app.my_profile'))
+@section('page-heading', trans('app.my_profile'))
+
+@section('breadcrumbs')
+    <li class="breadcrumb-item">
+        @lang('app.my_profile')
+    </li>
+
+    <li class="breadcrumb-item active">
+        @lang('app.two_factor_phone_verification')
+    </li>
+@stop
+
+@section('content')
+
+@include('partials.messages')
+
+<div class="row">
+    <div class="col-md-6 m-auto">
+        <div class="card">
+            <div class="card-body">
+                <h5 class="card-title card-title-bold">
+                    @lang('app.phone_verification')
+                </h5>
+
+                <p>@lang('app.we_have_sent_you_a_verification_token')</p>
+
+                {!! Form::open(['route' => "two-factor.verify", 'id' => 'two-factor-form']) !!}
+                    @if ($user)
+                        <input type="hidden" name="user" value="{{ $user }}">
+                    @endif
+                    <div class="form-group mt-4">
+                        <input type="text"
+                               class="form-control"
+                               id="token"
+                               name="token"
+                               placeholder="@lang('app.token')">
+                    </div>
+                    <div class="mt-3">
+                        <button type="submit"
+                                class="btn btn-primary"
+                                data-toggle="loader"
+                                data-loading-text="@lang('app.verifying')">
+                            @lang('app.verify')
+                        </button>
+                        <a href="javascript:;"
+                           class="btn d-none"
+                           id="resend-token"
+                           data-loading-text="@lang('app.sending')">
+                            @lang('app.resend_token')
+                        </a>
+                    </div>
+                {!! Form::close() !!}
+            </div>
+        </div>
+    </div>
+</div>
+
+@stop
+
+@section('scripts')
+    <script>
+        var user = {{ isset($user) ? $user : 'null' }};
+    </script>
+    {!! HTML::script('assets/js/as/btn.js') !!}
+    {!! HTML::script('assets/js/as/two-factor.js') !!}
+@stop
\ No newline at end of file
diff --git a/resources/views/user/view.blade.php b/resources/views/user/view.blade.php
index aeaf7bf..10d6022 100644
--- a/resources/views/user/view.blade.php
+++ b/resources/views/user/view.blade.php
@@ -22,6 +22,14 @@
                     @lang('app.details')
 
                     <small class="float-right">
+                        @canBeImpersonated($user)
+                            <a href="{{ route('impersonate', $user) }}"
+                               data-toggle="tooltip" data-placement="top" title="@lang('app.impersonate_user')">
+                                @lang('app.impersonate')
+                            </a>
+                            <span class="text-muted">|</span>
+                        @endCanBeImpersonated
+
                         <a href="{{ route('user.edit', $user->id) }}" class="edit"
                            data-toggle="tooltip" data-placement="top" title="@lang('app.edit_user')">
                             @lang('app.edit')
diff --git a/routes/api.php b/routes/api.php
index f3b7d1d..621b679 100644
--- a/routes/api.php
+++ b/routes/api.php
@@ -26,6 +26,7 @@ Route::get('me/sessions', 'Profile\SessionsController@index');
 
 if (settings('2fa.enabled')) {
     Route::put('me/2fa', 'Profile\TwoFactorController@update');
+    Route::post('me/2fa/verify', 'Profile\TwoFactorController@verify');
     Route::delete('me/2fa', 'Profile\TwoFactorController@destroy');
 }
 
@@ -39,6 +40,7 @@ Route::delete('users/{user}/avatar', 'Users\AvatarController@destroy');
 
 if (settings('2fa.enabled')) {
     Route::put('users/{user}/2fa', 'Users\TwoFactorController@update');
+    Route::post('users/{user}/2fa/verify', 'Users\TwoFactorController@verify');
     Route::delete('users/{user}/2fa', 'Users\TwoFactorController@destroy');
 }
 
diff --git a/routes/channels.php b/routes/channels.php
new file mode 100644
index 0000000..f16a20b
--- /dev/null
+++ b/routes/channels.php
@@ -0,0 +1,16 @@
+<?php
+
+/*
+|--------------------------------------------------------------------------
+| Broadcast Channels
+|--------------------------------------------------------------------------
+|
+| Here you may register all of the event broadcasting channels that your
+| application supports. The given channel authorization callbacks are
+| used to check if an authenticated user can listen to the channel.
+|
+*/
+
+Broadcast::channel('App.User.{id}', function ($user, $id) {
+    return (int) $user->id === (int) $id;
+});
diff --git a/routes/web.php b/routes/web.php
index 0de3bd8..f274385 100644
--- a/routes/web.php
+++ b/routes/web.php
@@ -61,6 +61,11 @@ Route::post('auth/twitter/email', 'Auth\SocialAuthController@postTwitterEmail');
 
 Route::group(['middleware' => 'auth'], function () {
 
+    /**
+     * Impersonate Routes
+     */
+    Route::impersonate();
+
     /**
      * Dashboard
      */
@@ -104,15 +109,43 @@ Route::group(['middleware' => 'auth'], function () {
         'uses' => 'ProfileController@updateLoginDetails'
     ]);
 
-    Route::post('profile/two-factor/enable', [
-        'as' => 'profile.two-factor.enable',
-        'uses' => 'ProfileController@enableTwoFactorAuth'
-    ]);
+    /**
+     * Two-Factor Authentication Setup
+     */
 
-    Route::post('profile/two-factor/disable', [
-        'as' => 'profile.two-factor.disable',
-        'uses' => 'ProfileController@disableTwoFactorAuth'
-    ]);
+    if (settings('2fa.enabled')) {
+        Route::post('two-factor/enable', [
+            'as' => 'two-factor.enable',
+            'uses' => 'TwoFactorController@enable'
+        ]);
+
+        Route::get('two-factor/verification', [
+            'as' => 'two-factor.verification',
+            'uses' => 'TwoFactorController@verification',
+            'middleware' => 'verify-2fa-phone'
+        ]);
+
+        Route::post('two-factor/resend', [
+            'as' => 'two-factor.resend',
+            'uses' => 'TwoFactorController@resend',
+            'middleware' => ['throttle:1,1', 'verify-2fa-phone']
+        ]);
+
+        Route::post('two-factor/verify', [
+            'as' => 'two-factor.verify',
+            'uses' => 'TwoFactorController@verify',
+            'middleware' => 'verify-2fa-phone'
+        ]);
+
+        Route::post('two-factor/disable', [
+            'as' => 'two-factor.disable',
+            'uses' => 'TwoFactorController@disable'
+        ]);
+    }
+
+    /**
+     * Sessions
+     */
 
     Route::get('profile/sessions', [
         'as' => 'profile.sessions',
@@ -370,4 +403,4 @@ $router->get('install/complete', [
 $router->get('install/error', [
     'as' => 'install.error',
     'uses' => 'InstallController@error'
-]);
\ No newline at end of file
+]);
diff --git a/storage/framework/cache/.gitignore b/storage/framework/cache/.gitignore
index c96a04f..70baa10 100755
--- a/storage/framework/cache/.gitignore
+++ b/storage/framework/cache/.gitignore
@@ -1,2 +1,3 @@
 *
+!/data
 !.gitignore
\ No newline at end of file
diff --git a/storage/framework/cache/data/.gitignore b/storage/framework/cache/data/.gitignore
new file mode 100755
index 0000000..c96a04f
--- /dev/null
+++ b/storage/framework/cache/data/.gitignore
@@ -0,0 +1,2 @@
+*
+!.gitignore
\ No newline at end of file
diff --git a/tests/Feature/FunctionalTestCase.php b/tests/Feature/FunctionalTestCase.php
index a3e9015..742655f 100644
--- a/tests/Feature/FunctionalTestCase.php
+++ b/tests/Feature/FunctionalTestCase.php
@@ -97,15 +97,25 @@ class FunctionalTestCase extends TestCase
      */
     protected function createAndLoginAdminUser(array $attributes = [], $guard = null)
     {
-        $user = $this->createUser($attributes);
-
-        $user = $this->setRoleForUser($user, 'Admin');
+        $user = $this->createAdminUser($attributes);
 
         $this->be($user, $guard);
 
         return $user;
     }
 
+    /**
+     * @param array $attributes
+     * @param null $guard
+     * @return mixed
+     */
+    protected function createAdminUser(array $attributes, $guard = null)
+    {
+        return $this->createUser(array_merge($attributes, [
+            'role_id' => Role::where('name', 'Admin')->first()
+        ]));
+    }
+
     /**
      * @param array $attributes
      * @return mixed
diff --git a/tests/Feature/Http/Controllers/Api/Auth/AuthControllerTest.php b/tests/Feature/Http/Controllers/Api/Auth/AuthControllerTest.php
index 683e429..248075c 100644
--- a/tests/Feature/Http/Controllers/Api/Auth/AuthControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/Auth/AuthControllerTest.php
@@ -3,17 +3,13 @@
 namespace Tests\Feature\Http\Controllers\Api\Auth;
 
 use Carbon\Carbon;
-use Illuminate\Foundation\Testing\RefreshDatabase;
 use Tests\Feature\ApiTestCase;
-use Tests\MailTrap;
 use Portal\Services\Auth\Api\Token;
 use Portal\Support\Enum\UserStatus;
 use Portal\User;
 
 class AuthControllerTest extends ApiTestCase
 {
-    use MailTrap;
-
     public function test_login()
     {
         $credentials = [
diff --git a/tests/Feature/Http/Controllers/Api/Auth/Password/RemindControllerTest.php b/tests/Feature/Http/Controllers/Api/Auth/Password/RemindControllerTest.php
index 4cb7132..2410e54 100644
--- a/tests/Feature/Http/Controllers/Api/Auth/Password/RemindControllerTest.php
+++ b/tests/Feature/Http/Controllers/Api/Auth/Password/RemindControllerTest.php
@@ -2,52 +2,39 @@
 
 namespace Tests\Feature\Http\Controllers\Api\Auth\Password;
 
-use Carbon\Carbon;
+use Illuminate\Support\Facades\Notification;
 use Tests\Feature\ApiTestCase;
-use Tests\MailTrap;
-use Portal\Events\User\RequestedPasswordResetEmail;
-use Portal\Services\Auth\Api\Token;
 use Portal\User;
 
 class RemindControllerTest extends ApiTestCase
 {
-    use MailTrap;
-
     public function test_send_password_reminder()
     {
-        factory(User::class)->create(['email' => 'test@test.com']);
+        Notification::fake();
 
-//        $this->expectsEvents(RequestedPasswordResetEmail::class);
+        $user = factory(User::class)->create(['email' => 'test@test.com']);
 
-        $this->postJson('api/password/remind', [
-            'email' => 'test@test.com'
-        ]);
+        $this->postJson('api/password/remind', ['email' => 'test@test.com']);
 
         $this->assertResponseOk();
 
-        $message = $this->fetchInbox()[0];
+        Notification::assertSentTo(
+            $user,
+            \Portal\Notifications\ResetPassword::class,
+            function ($notification) {
+                $mail = $notification->toMail()->toArray();
 
-        $this->assertEquals('test@test.com', $message['to_email']);
-        $this->assertEquals(config('mail.from.address'), $message['from_email']);
-        $this->assertEquals(config('mail.from.name'), $message['from_name']);
-        $this->assertContains(
-            trans('app.request_for_password_reset_made'),
-            $message['html_body']
-        );
+                $this->assertContains(trans('app.request_for_password_reset_made'), $mail['introLines']);
+                $this->assertContains(trans('app.if_you_did_not_requested'), $mail['outroLines']);
 
-        $this->assertContains(
-            trans('app.if_you_did_not_requested'),
-            $message['html_body']
+                return true;
+            }
         );
-
-        $this->emptyInbox();
     }
 
     public function test_password_reminder_with_wrong_email()
     {
-        $this->postJson('api/password/remind', [
-            'email' => 'test@test.com'
-        ]);
+        $this->postJson('api/password/remind', ['email' => 'test@test.com']);
 
         $this->assertResponseStatus(422)
             ->seeJsonEquals([
